<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/24/2009 *
 * ===================                          Last change: 11/24/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-grade.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Grades for your members                          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Einstufungen Ihrer Mitglieder                    *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.0.0');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0'));

// This extension is in development (non-productive)
enableExtensionProductive(false);

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running
		// General and grade level data
		addDropTableSql('grade_data');
		addCreateTableSql('grade_data', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`grade_name` VARCHAR(255) NOT NULL DEFAULT '',
`grade_description` TINYTEXT NOT NULL,
`grade_parent_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
PRIMARY KEY (`id`),
UNIQUE (`grade_name`),
INDEX (`grade_parent_id`)",
			'Grade general data');

		// Data for if a grade level has been reached
		addDropTableSql('grade_cash_data');
		addCreateTableSql('grade_cash_data', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`grade_cash_name` VARCHAR(255) NOT NULL DEFAULT '',
`grade_cash_type` ENUM('DISCOUNT','BONUS') NOT NULL DEFAULT 'DISCOUNT',
`reached_points` FLOAT(20,5) UNSIGNED NULL DEFAULT NULL,
`reached_mails` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`time_valid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
PRIMARY KEY (`id`),
UNIQUE (`grade_cash_name`)",
			'Grade data if the grade have been "cashed"');

		// Connection grade<->cash data
		addDropTableSql('grade_cash_connect');
		addCreateTableSql('grade_cash_connect', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`grade_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`grade_cash_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
PRIMARY KEY (`id`),
UNIQUE INDEX `grade_cash` (`grade_id`,`grade_cash_id`),
INDEX (`grade_cash_id`)",
			'Grade<->cash data connection');

		// Connection grade<->user data
		addDropTableSql('grade_user_connect');
		addCreateTableSql('grade_user_connect', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`grade_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`grade_expired` TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00',
PRIMARY KEY (`id`),
UNIQUE (`userid`,`grade_id`),
INDEX (`grade_id`)",
			'Grade<->user connection');

		// Admin menu entries
		addAdminMenuSql('grade', NULL, 'Einstufungen', 'Stufen Sie Ihre Mitglieder ein, die sie ab einer einstellbaren Anzahl an {?POINTS?} oder best&auml;tigten Mails usw. erhalten und durch die Einstufung Erm&auml;&szlig;igungen oder Sonderboni erhalten k&ouml;nnen.', 6);
		addAdminMenuSql('grade', 'list_grades', 'Auflisten...', 'Listet alle Einstufungen auf, auch sind diese hier editierbar, neue hinzuf&uuml;gbar und l&ouml;schbar.', 1);
		addAdminMenuSql('grade', 'list_cash_grade', 'Erm&auml;&szlig;igungen/Sonderboni', 'Listet alle Erm&auml;&szlig;igungen/Sonderbi auf, auch sind diese hier editierbar, neue hinzuf&uuml;gbar und l&ouml;schbar.', 2);
		addAdminMenuSql('grade', 'list_current_grades', 'Mitglieder-Einstufungen', 'Liste alle durch die Mitglieder aktuell erreichten Einstungen auf. Diese sind nicht editierbar (wir wollen ja nicht schummeln und bestimmten Mitgliedern bessere Einstufungen geben, oder? ;-) ).', 3);
		addAdminMenuSql('grade', 'config_grade', 'Einstellungen ...', 'Diverse Einstellungen zu den Einstufungen.', 4);

		// Member menu
		addMemberMenuSql('account', 'grade', 'Erreichte Stufe', 2);

		// Guest menu
		addGuestMenuSql('members', 'grade', 'Einstufungen', 4);
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addDropTableSql('grade_data');
		addDropTableSql('grade_cash_data');
		addDropTableSql('grade_cash_connect');
		addDropTableSql('grade_user_connect');

		// Menu entries
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `action`='grade' LIMIT 5");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what`='grade' LIMIT 1");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE `what`='grade' LIMIT 1");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `locked`='N', `visible`='Y' WHERE `what`='grade' LIMIT 1");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `locked`='N', `visible`='Y' WHERE `what`='grade' LIMIT 1");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `locked`='Y', `visible`='N' WHERE `what`='grade' LIMIT 1");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `locked`='Y', `visible`='N' WHERE `what`='grade' LIMIT 1");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addExtensionSql('');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes('');
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
