<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/31/2008 *
 * ===================                          Last change: 08/31/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_surfbar.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Configuration for surfbar                        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Konfiguration fuer Surfbar                       *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// Was the form submitted?
if (isFormSent()) {
	// Replace german decimal comma with computer decimal dot
	convertCommaToDotInPostDataArray(array('surfbar_static_reward', 'surfbar_static_costs', 'surfbar_dynamic_percent'));

	// Save settings
	adminSaveSettingsFromPostData();
} else {
	// Prepare content
	$content = array(
		'surfbar_static_time'     => createConfigurationTimeSelections('surfbar_static_time'   , 'ms' , 'left'),
		'surfbar_static_lock'     => createConfigurationTimeSelections('surfbar_static_lock'   , 'hm' , 'left'),
		'surfbar_restart_time'    => createConfigurationTimeSelections('surfbar_restart_time'  , 'ms' , 'left'),
		'surfbar_stats_reload'    => createConfigurationTimeSelections('surfbar_stats_reload'  , 'ms' , 'left'),
		'surfbar_purge_deleted'   => createConfigurationTimeSelections('surfbar_purge_deleted' , 'WDh', 'left'),
		'surfbar_purge_migrated'  => createConfigurationTimeSelections('surfbar_purge_migrated', 'WDh', 'left'),
		'surfbar_low_interval'    => createConfigurationTimeSelections('surfbar_low_interval'  , 'WDh', 'left'),
	);

	// Even some more...
	foreach (array('surfbar_payment_model_static','surfbar_payment_model_dynamic','surfbar_pause_mode_internal','surfbar_pause_mode_external','surfbar_notification_mode_instant','surfbar_notification_mode_reset') as $entry) {
		$content[$entry] = '';
	} // END - foreach

	// Prepare selections
	foreach (array('surfbar_payment_model','surfbar_pause_mode','surfbar_notification_mode') as $entry) {
		$content[$entry . '_' . strtolower(getConfig($entry))] = ' checked="checked"';
	} // END - foreach

	// Load template
	loadTemplate('admin_config_surfbar', false, $content);
}

// [EOF]
?>
